services:

  vuelo:
    image: endgen/vuelo
    tty: true
    stdin_open: true
    volumes:
      - .:/srv/workspace
    ports:
      - "3000:3000"             # Sandbox
      - "9000:9000"             # Preview; single-use port for production previews
      - "6006:6007"             # Storybook
      - "3001-3001:3001-3001"   # Apps; incremement this port range as more apps are added
    environment:
      DB_SUPERUSER_URL: postgresql://postgres@postgres
      DB_ADMIN_URL: postgresql://admin@postgres
      DB_API_URL: postgresql://api@postgres
      DB_GRAPHQL_URL: postgresql://graphql@postgres
      DB_CONNECTOR_URL: postgresql://connector@postgres
      DB_CONSUMER_URL: postgresql://consumer@postgres
      DB_HYDRATION: all
      EVENT_BROKER_URLS: kafka:9092
      EVENT_CONNECTOR_URL: http://vuelo-connector:8083
      EVENT_CONSUMERS_ENABLED: all
      SDK_HMR_WS_PROTOCOL: ${SDK_HMR_WS_PROTOCOL:-}
    # env_file:
    #   - .env

  postgres:
    image: postgis/postgis:16-master
    # REPLICATION
    #wal_level = logical              # minimal, archive, hot_standby, or logical (change requires restart)
    #max_wal_senders = 4              # max number of walsender processes (change requires restart)
    #wal_keep_segments = 4            # in logfile segments, 16MB each; 0 disables
    #wal_sender_timeout = 60s         # in milliseconds; 0 disables
    #max_replication_slots = 4        # max number of replication slots (change requires restart)
    command: [
      "postgres",
      "-c", "work_mem=64MB",
      "-c", "max_connections=120",
      "-c", "shared_buffers=500MB",
      "-c", "log_statement=all",
      "-c", "log_min_messages=NOTICE",
      "-c", "wal_level=logical",
      "-c", "max_replication_slots=10"      # This number must be >= the number of Vuelo apps
    ]
    volumes:
      - /var/lib/postgresql/data
      - ./.postgres/initdb.d:/docker-entrypoint-initdb.d
    ports:
      - "5432:5432"
    environment:
      POSTGRES_HOST_AUTH_METHOD: trust

  pgadmin:
    image: dpage/pgadmin4:8.6
    depends_on:
      - postgres
    volumes:
      - pgadmin:/var/lib/pgadmin
    ports:
      - "7000:80"
    environment:
      PGADMIN_DEFAULT_EMAIL: ${PGADMIN_DEFAULT_EMAIL:-admin@postgres.vuelo}
      PGADMIN_DEFAULT_PASSWORD: ${PGADMIN_DEFAULT_PASSWORD:-vuelo}
      PGADMIN_CONFIG_MAX_LOGIN_ATTEMPTS: 0

  zookeeper:
    image: debezium/zookeeper:2.7
    volumes:
      - /zookeper/data
      - /zookeper/txns

  kafka:
    # ZooKeeper has a 18 second session timeout, so sleep for 20s between restarts
    entrypoint: sh -c 'sleep 20; /docker-entrypoint.sh start'
    image: debezium/kafka:2.7
    volumes:
      - /kafka/data
    environment:
      ZOOKEEPER_CONNECT: zookeeper:2181

  vuelo-connector:
    image: debezium/connect:2.7
    depends_on:
      - kafka
      - postgres
    environment:
      - GROUP_ID=vuelo
      - CONFIG_STORAGE_TOPIC=vuelo_configs
      - OFFSET_STORAGE_TOPIC=vuelo_offsets
      - STATUS_STORAGE_TOPIC=vuelo_statuses
      - BOOTSTRAP_SERVERS=kafka:9092

volumes:
  pgadmin:
